//
// HDAdditions.h
// -------------------------------------------------------------------------
// Copyright (C) 2007 Andrew Merenbach <http://www.merenbach.com/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>

#define HD_KILOBYTE (2 << 9)	/* 1024 */
#define HD_MEGABYTE (2 << 19)	/* 1048576 */
#define HD_GIGABYTE (2 << 29)	/* 1073741824 */


extern NSString *HDMainBundleName();
extern NSString *HDMainBundleIdentifier();
extern NSString *HDApplicationSupportDirectory();
extern NSString *HDPreferencesPath();


@interface NSArrayController (HDAdditions)
- (void)removeAllArrangedObjects:(id)sender;
- (id)objectAtArrangedObjectIndex:(unsigned)idx;
- (NSArray *)valuesForKey:(NSString *)key;
@end

@interface NSWorkspace (HDAdditions)
+ (BOOL)deleteFileAtPath:(NSString *)path;
@end