//
//  HDDownloadEntry.h
// -------------------------------------------------------------------------
// Copyright (C) 2007 Andrew Merenbach <http://www.merenbach.com/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------


#import <Cocoa/Cocoa.h>
#import "HDTransferSourceEntry.h"

// new
extern NSString *HDTransferSourceDownloadsPExpandableKey;

extern NSString *HDTransferSourceDownloadsURLKey;
extern NSString *HDTransferSourceDownloadsSizeKey;
extern NSString *HDTransferSourceDownloadsFileKey;
extern NSString *HDTransferSourceDownloadsUserKey;
extern NSString *HDTransferSourceDownloadsHashKey;
extern NSString *HDTransferSourceDownloadsStateKey;
extern NSString *HDTransferSourceDownloadsStatusKey;
extern NSString *HDTransferSourceDownloadsTransmitKey;

extern NSString *HDTransferSourceDownloadsPSourcesKey;
extern NSString *HDTransferSourceDownloadsPSourcesDictKey;

extern NSString *HDTransferSourceDownloadsPTransferKey;
//extern NSString *HDTransferSourceDownloadsPSizeKey;

extern NSString *HDTransferSourceDownloadsTotalKey;

extern NSString *PZDownloadEntryFileInfoArray;
extern NSString *PZDownloadEntryFileSizeString;

extern NSString *HDDownloadEntryPIconKey;


@interface HDDownloadEntry : HDTransferSourceEntry {
@private

	NSMutableArray *AM_children;
	NSMutableDictionary *AM_entryDictionary;
}

- (id)init;
- (void)dealloc;

- (NSMutableDictionary *)entryDictionary;
- (void)setEntryDictionary:(NSDictionary *)aDict;

- (NSMutableArray *)children;
- (void)setChildren:(NSArray *)anArray;

@end


@interface HDDownloadEntry (KeyAccessorMethods)

- (NSArray *)fileInfoArray;
- (void)setFileInfoArray:(NSArray *)aString;

- (NSString *)fileSizeString;
- (void)setFileSizeString:(NSString *)aString;

@end
