//
// HDNetworkEntry.m
// -------------------------------------------------------------------------
// Copyright (C) 2007 Andrew Merenbach <http://www.merenbach.com/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>

extern NSString *PZNetworkEntryIconKey;
extern NSString *PZNetworkEntrySummaryKey;

extern NSString *PZNetworkEntryProtocolNameKey;
extern NSString *PZNetworkEntryNetworkPopulationKey;

@interface HDNetworkEntry : NSObject {
@private

	NSDictionary *AM_entryDictionary;
	
	//BOOL AM_cellHighlighted;
}

- (id)init;
- (id)initWithEntryDictionary:(NSDictionary *)aDictionary;
- (void)dealloc;

/*- (BOOL)isCellHighlighted;
- (void)setCellHighlighted:(BOOL)flag;

- (NSAttributedString *)summary;*/
- (NSAttributedString *)summaryAttributedStringWithHighlight:(BOOL)highlighted;

- (NSMutableDictionary *)entryDictionary;
- (void)setEntryDictionary:(NSDictionary *)aDictionary;

@end

@interface HDNetworkEntry (KeyAccessors)

- (NSImage *)iconImage;
- (void)setIconImage:(NSImage *)anImage;

- (NSArray *)protocolArray;
- (void)setProtocolArray:(NSArray *)anArray;

- (NSString *)protocolName;
- (void)setProtocolName:(NSString *)aString;

- (NSString *)networkPopulation;
- (void)setNetworkPopulation:(NSString *)aString;

@end