//
//  HDSearchListEntry.h
// -------------------------------------------------------------------------
// Copyright (C) 2007 Andrew Merenbach <http://www.merenbach.com/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>

extern NSString *PZSearchListEntryDictionaryKey;
extern NSString *PZSearchListEntryTicketStringKey;
extern NSString *PZSearchListEntryResultCountKey;
extern NSString *PZSearchListEntryQueryStringKey;
extern NSString *PZSearchListEntryInfoStringKey;

extern NSString *PZSearchListEntrySummaryKey;
extern NSString *PZSearchListEntryEntryDataSourceKey;

@class HDSearchResultSource;


@interface HDSearchListEntry : NSObject {
	NSMutableDictionary *AM_entryDictionary;
	
	HDSearchResultSource *AM_entryDataSource;
}

- (id)init;
- (void)dealloc;

//- (NSArray *)summary;

- (NSMutableDictionary *)entryDictionary;
- (void)setEntryDictionary:(NSDictionary *)aDictionary;

- (NSAttributedString *)summaryAttributedStringWithHighlight:(BOOL)highlighted;

- (id)entryDataSource;
- (void)setEntryDataSource:(id)aDataSource;

@end

@interface HDSearchListEntry (KeyAccessorMethods)

- (NSString *)ticketString;
- (void)setTicketString:(NSString *)aString;

- (NSString *)queryString;
- (void)setQueryString:(NSString *)aString;

- (NSString *)resultCount;
- (void)setResultCount:(NSString *)aString;

- (NSString *)infoString;
- (void)setInfoString:(NSString *)aString;

@end
