//
//  HDSearchResultEntry.m
// -------------------------------------------------------------------------
// Copyright (C) 2007 Andrew Merenbach <http://www.merenbach.com/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------

#import "HDSearchResultEntry.h"

NSString *PZSearchResultEntryFilenameKey = @"file";	// [TODO] change to @"filename"


@implementation HDSearchResultEntry

- (id)init {
	if (nil != (self = [super init])) {
		[self setEntryDictionary:nil];
		[self setChildren:nil];
	}
	return self;
}

- (void)dealloc {
	[self setEntryDictionary:nil];
	[self setChildren:nil];
	
	[super dealloc];
}

- (NSMutableDictionary *)entryDictionary {
	return [[AM_entryDictionary retain] autorelease];
}

- (void)setEntryDictionary:(NSDictionary *)aDict {
	if (aDict != AM_entryDictionary) {
		[AM_entryDictionary release];
		AM_entryDictionary = [aDict mutableCopy];
	}
}

- (NSArray *)children {
	return [[AM_children retain] autorelease];
}

- (void)setChildren:(NSArray *)anArray {
	if (anArray != AM_children) {
		[AM_children release];
		AM_children = [anArray copy];
	}
}


@end

@implementation HDSearchResultEntry (KeyAccessorMethods)

- (NSString *)filenameString {
	return [[self entryDictionary] objectForKey:PZSearchResultEntryFilenameKey];
}

- (void)setFilenameString:(NSString *)aString {
	[[self entryDictionary] setObject:aString forKey:PZSearchResultEntryFilenameKey];
}

/*- (NSString *)filenameString {
	return [[AM_filenameString retain] autorelease];
}

- (void)setFilenameString:(NSString *)aString {
	if (aString != AM_filenameString) {
		[AM_filenameString release];
		AM_filenameString = [aString copy];
	}
}*/

@end
