//
//  HDSearchResultsCornerView.h
//  Tab Size: 3
// -----------------------------------------------------------------
//  Copyright (c) 2003 Aaron Sittig. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or
//  without modification, are permitted provided that the
//  following conditions are met:
//
//  1 Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
//  2 Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with distribution.
//  3 Neither the name of Aaron Sittig nor the names of contributors
//    may be used to endorse or promote products derived from this
//    software without specific prior written permission.
//  -----------------------------------------------------------------

//  PTableMenu is an NSTableView Category to facilitate attaching a
//  popup menu to the upper right hand corner.

#import "Cocoa/Cocoa.h"

// We derive from NSPopUpButtonCell to retain behavior but
// modify the appearance to match the table header bar
@interface HDSearchResultsCornerView : NSPopUpButtonCell {
	NSTableHeaderCell *headerCell;
	NSImage *headerImage;
}

- (id)initTextCell:(NSString *)stringValue pullsDown:(BOOL)pullDown;
- (void)dealloc;

- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;

@end
