//
//  HDSearchResultsCornerView.h
//  Tab Size: 3
// -----------------------------------------------------------------
//  Copyright (c) 2003 Aaron Sittig. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or
//  without modification, are permitted provided that the
//  following conditions are met:
//
//  1 Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
//  2 Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with distribution.
//  3 Neither the name of Aaron Sittig nor the names of contributors
//    may be used to endorse or promote products derived from this
//    software without specific prior written permission.
//  -----------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------


#import "HDSearchResultsCornerView.h"


@implementation HDSearchResultsCornerView

- (id)initTextCell:(NSString *)stringValue pullsDown:(BOOL)pullDown {
	if (nil != (self = [super initTextCell:stringValue pullsDown:pullDown])) {
		headerCell = [[NSTableHeaderCell alloc] initTextCell:@""];
		headerImage = [[NSImage imageNamed:@"table-menu"] retain];
	}
	return self;
}

- (void)dealloc {
	[headerCell release];
	headerCell = nil;
	
	[headerImage release];
	headerImage = nil;
	
	[super dealloc];
}

- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
	NSPoint	point = cellFrame.origin;
	
	// Flip Point to draw Icon
	if ([controlView isFlipped])
		point.y += cellFrame.size.height;
	
	// Draw Background with NSTableHeaderCell
	[headerCell drawWithFrame:cellFrame inView:controlView];
	
	// Draw Table Menu Icon if Menu Attached
	if ([self menu]) {
		[headerImage compositeToPoint:point operation:NSCompositeSourceOver];
	}
}

@end
