//
// PDownloadsOutlineView.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "PDownloadsOutlineView.h"
#import "HDAspectControllerDownloads.h"

const float PZDownloadsOutlineViewDefaultSmallRowHeight = 16.0;


@implementation PDownloadsOutlineView

- (id)init {
	if (nil != (self = [super init])) {
		[self setSmallRowHeight:PZDownloadsOutlineViewDefaultSmallRowHeight];
	}
	return self;
}

- (id)initWithFrame:(NSRect)frameRect {
	if (nil != (self = [super initWithFrame:frameRect])) {
		[self setSmallRowHeight:PZDownloadsOutlineViewDefaultSmallRowHeight];
	}
	return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder {
	if (nil != (self = [super initWithCoder:aDecoder])) {
		[self setSmallRowHeight:PZDownloadsOutlineViewDefaultSmallRowHeight];
	}
	return self;
}


- (void)keyDown:(NSEvent *)theEvent
{
	NSString *keys = [theEvent characters];
	if ([keys length]==1 && [keys characterAtIndex:0]==NSDeleteCharacter || [keys characterAtIndex:0]==NSDeleteFunctionKey || [keys characterAtIndex:0]==NSDeleteCharFunctionKey && [[self delegate] respondsToSelector:@selector(deleteEvent:)]) [[self delegate] performSelector:@selector(deleteEvent:)];
	else [super keyDown:theEvent];
}

- (void)setMenuDelegate:(id)new_menu_delegate
{
	_menu_delegate = new_menu_delegate;
}

- (NSMenu *)menuForEvent:(NSEvent*)event 
{
	id menu = nil;

	NSPoint point = [self convertPoint:[event locationInWindow] fromView:nil];
	int column = [self columnAtPoint:point];
	int row = [self rowAtPoint:point];
	
	if ([_menu_delegate respondsToSelector:@selector(tableView:menuForTableColumn:row:)] )
		menu = [_menu_delegate tableView:self
			menuForTableColumn:[[self tableColumns] objectAtIndex:column]
			row:row];
			
	return menu;
}

- (float)smallRowHeight {
	return AM_smallRowHeight;
}

- (void)setSmallRowHeight:(float)aFloat {
	AM_smallRowHeight = aFloat;
}

@end
