//
// PNetworksTableTitleDescriptionCell.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "PUploadTitleDescriptionCell.h"
#import "HDAttributedStringCellFontController.h"

const float PUploadTitleDescriptionCellInset = 4.0;


@implementation PUploadTitleDescriptionCell

- (NSAttributedString *)generatedAttributedStringWithHighlight:(BOOL)highlighted {
	NSMutableAttributedString *attributedString = [[NSMutableAttributedString alloc] initWithString:@""];

	id objectValue = [self objectValue];
	if ([objectValue respondsToSelector:@selector(count)]) {
		if ([objectValue count] >= 2 && [objectValue count] <= 3) {
			NSDictionary *boldFont;
			NSDictionary *normalFont;
			NSDictionary *tinyFont;
			
			if (highlighted) {
				boldFont = [HDAttributedStringCellFontController highlightedBoldFontDictionary];
				normalFont = [HDAttributedStringCellFontController highlightedNormalFontDictionary];
				tinyFont = [HDAttributedStringCellFontController highlightedTinyFontDictionary];
			} else {
				boldFont = [HDAttributedStringCellFontController unhighlightedBoldFontDictionary];
				normalFont = [HDAttributedStringCellFontController unhighlightedNormalFontDictionary];
				tinyFont = [HDAttributedStringCellFontController unhighlightedTinyFontDictionary];
			}
			
			id cellValue = [self objectValue];
			if ([[cellValue objectAtIndex:0] boolValue]) {
				NSAttributedString *spacer = [[NSAttributedString alloc] initWithString:@"\n" attributes:[NSDictionary dictionaryWithObject:[HDAttributedStringCellFontController spacingParagraphStyle:PUploadTitleDescriptionCellInset] forKey:NSParagraphStyleAttributeName]];
				NSAttributedString *line1 = [[NSAttributedString alloc] initWithString:[objectValue objectAtIndex:1] attributes:boldFont];
				NSAttributedString *newline = [[NSAttributedString alloc] initWithString:@"\n"];
				NSAttributedString *line2 = [[NSAttributedString alloc] initWithString:[objectValue objectAtIndex:2] attributes:tinyFont];

				[attributedString appendAttributedString:spacer];
				[attributedString appendAttributedString:line1];
				[attributedString appendAttributedString:newline];
				[attributedString appendAttributedString:line2];
				
				[spacer release];
				[line1 release];
				[newline release];
				[line2 release];
			} else {
				NSAttributedString *line1 = [[NSAttributedString alloc] initWithString:[objectValue objectAtIndex:1] attributes:normalFont];
				[attributedString appendAttributedString:line1];
				[line1 release];
			}
		}
	}
	
	return [attributedString autorelease];
}

@end
