//
//  HDAspectController.m
// -------------------------------------------------------------------------
// Copyright (C) 2007 Andrew Merenbach <http://www.merenbach.com/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2003 Poisoned Project <http://www.gottsilla.net>
// ---------------------------------------------------------------------------


#import "HDAspectController.h"


@implementation HDAspectController

- (id)init {
	if (nil != (self = [super init])) {
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didConnect:) name:@"HederaConnectedToCore" object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didDisconnect:) name:@"DaemonConnectionClosed" object:nil];
	}
	return self;
}

- (void)dealloc {
	[view release];
	view = nil;
	
	[super dealloc];
}

// return the content view; needed by HDMainController
- (NSView *)view {
	return [[view retain] autorelease];
}

- (void)didConnect:(NSNotification *)aNotification {
	// meant to be overridden, so do nothing
}

- (void)didDisconnect:(NSNotification *)aNotification {
	// meant to be overridden, so do nothing
}

/*- (HDDaemonCommander *)commander {
	return commander;
}

- (void)setCommander:(HDDaemonCommander *)aCommander {
	commander = aCommander;
}*/

- (void)registerWithCommander {
	// meant to override, so do nothing here
}

@end
