//
// HDAspectControllerDaemon.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDAspectController.h"

#import "HDControllerProtocol.h"
#import "HDDaemonCommander.h"
#import "HDDaemonCommands.h"
#import "HDPreferencesConfigurationEditorGiFT.h"
#import "HDPreferencesConfigurationEditorUI.h"
#import "HDPreferencesConfigurationEditorOpenFT.h"
#import "HDPreferencesConfigurationEditorGnutella.h"

@class PIconShop;
@class HDNetworkEntry;
@class AMTableView;


@interface HDAspectControllerDaemon : HDAspectController <HDDaemonCommands>
{
	// [AM] begin new stuff
		BOOL AM_daemonIsRunning;
		NSTimer *daemonRunningTimer;
	
		IBOutlet NSArrayController *protocolArrayController;
		HDNetworkEntry *entryForNotConnected;
		HDNetworkEntry *entryForStoppingGiFT;
		HDNetworkEntry *entryForStartingGiFT;
		HDNetworkEntry *entryForDisconnectingFromDaemon;
		HDNetworkEntry *entryForConnectingToDaemon;
	
	// [AM] end new stuff
		
	//IBOutlet NSMenuItem *connectMenu;
	
	IBOutlet AMTableView *protocolTableView;
	
	IBOutlet NSPanel *connectionSheet;
	IBOutlet NSTextField *remoteAddressField;
	IBOutlet NSTextField *remotePortField;
	//IBOutlet NSMenuItem *remoteConnectMenu;
	
	//IBOutlet NSImageView *statusImage;
		
	//IBOutlet NSTextField *stats_field;
	
	NSUserDefaults *userDefaults;
	
	int crashes;
	
	NSTask *task;
	NSTimer *timer;		// timer for the STATS command
	NSString *AM_attachString;		// giFT & version
	
	PIconShop *icon_shop;	// protcol icons
		
	//BOOL shouldBeConnected;	// if this is YES and disconnected gets called -> giFT crashed
	//BOOL remoteDaemon;
	//BOOL _startDaemon;
	
	BOOL AM_protosSend;
	BOOL AM_synchronizing;
	

	
	// we need this when we get the DaemonConnectionClosed notification
	// YES -> the user closed the connection
	// NO  -> connection closed	=> error
	BOOL AM_userDisconnected;
	BOOL AM_startingDaemon;
	BOOL AM_remoteDaemon;
	BOOL AM_connectOnce;
}

- (void)periodicalUpdate;

//- (void)gui_update:(BOOL)activeView;

- (void)didConnect:(NSNotification *)aNotification;
- (void)connectionDidFail:(NSNotification *)aNotification;
// - (void)disconnected:(id)sender -> this is already defined in HDControllerProtocol.h

- (IBAction)launchDaemon:(id)sender;			// startgift button
- (void)startDaemon;

- (void)giftCrashNotification;			// user gift crash notification

//- (void)UpShutdown;
- (IBAction)connectToLocalDaemon:(id)sender;
- (BOOL)instantiateConnectionToLocalDaemon;

// remote connections
- (IBAction)connectToRemoteDaemon:(id)sender;
- (IBAction)closeRemoteConnectionSheet:(id)sender;
- (void)remoteConnectionSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void)initiateConnectionToRemoteDaemon;

// conf files
- (void)checkConfFiles;
- (BOOL)checkForItemAtPath:(NSString *)path;

- (void)askAboutReset;
- (void)tryToShutdownGiFTForReset;
//- (void)detectedGiFTRunningAlertSheetDidEnd:(NSAlert *)alert returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void)finishResettingProgram;
//- (void)resetProgramAlertSheetDidEnd:(NSAlert *)alert returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (NSString *)attachString;
- (void)setAttachString:(NSString *)aString;

@end

@interface HDAspectControllerDaemon (Internal)
- (void)am_resetProgram;
- (BOOL)am_isDaemonRunningCache;
- (void)am_setDaemonRunningCache:(BOOL)flag;
@end