//
// HDAspectControllerDownloads.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDAspectController.h"

#import "HDDownloadCommands.h"


@class HDTransferSourceDownloads;
@class PDownloadsOutlineView;

@interface HDAspectControllerDownloads : HDAspectController <HDDownloadCommands> 
{
	IBOutlet NSTreeController *downloadsTreeController;

    IBOutlet PDownloadsOutlineView *table;
    //IBOutlet NSTextField *infoField;
    //IBOutlet NSTextField *globalField;
    
    HDTransferSourceDownloads *dataSource;
        
    NSMutableSet *hashes;
    
    IBOutlet NSMenu *contextualMenu;
}

- (NSSet *)hashes;

- (IBAction)cancelDownload:(id)sender;
- (void)cancelSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (IBAction)pauseDownload:(id)sender;
- (IBAction)resumeDownload:(id)sender;
- (IBAction)delsource:(id)sender;
- (NSString *)hostForBrowsing;
- (IBAction)browseDownloadHost:(id)sender;
- (IBAction)cleanUpDownloads:(id)sender;
- (IBAction)expandAll:(id)sender;
- (IBAction)collapseAll:(id)sender;
- (IBAction)reveal:(id)sender;

//- (void)gui_update:(BOOL)activeView;

- (NSMenu *)tableView:(NSOutlineView *)_table menuForTableColumn:(NSTableColumn *)_column row:(int)_row;

- (int)downloadSpeed;
- (void)doDelete;

- (IBAction)findMoreSources:(id)sender;

- (IBAction)openFile:(id)sender;
- (IBAction)previewFile:(id)sender;

#pragma mark -
#pragma mark Download Commands

// these three are from the HDDownloadCommands protocol
- (oneway void)ADDDOWNLOAD:(in NSArray *)data;
- (oneway void)CHGDOWNLOAD:(in NSArray *)data;
- (oneway void)DELDOWNLOAD:(in NSArray *)data;

// these two are not, currently
- (void)ADDSOURCE:(NSArray *)data;
- (void)DELSOURCE:(NSArray *)data;

@end


@interface HDAspectControllerDownloads (Internal)
- (void)previewFileWithName:(NSString *)filename;
@end
