//
// HDAspectControllerUploads.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDAspectController.h"

#import "HDUploadCommands.h"


@class PUploadsTableView;
@class HDTransferSourceUploads;

@interface HDAspectControllerUploads : HDAspectController <HDUploadCommands>
{
    IBOutlet PUploadsTableView *table;
    IBOutlet NSMenu *contextualMenu;    
    HDTransferSourceUploads *dataSource;
}

- (IBAction)cancelUpload:(id)sender;
- (IBAction)pauseUpload:(id)sender;
- (IBAction)resumeUpload:(id)sender;
- (IBAction)delsource:(id)sender;
- (NSString *)hostForBrowsing;
- (IBAction)browseUploadHost:(id)sender;
- (IBAction)cleanUpUploads:(id)sender;
//- (IBAction)expand:(id)sender;
//- (IBAction)collapse:(id)sender;

//- (void)gui_update:(BOOL)activeView;

- (int)uploadSpeed;

- (NSMenu *)tableView:(NSTableView *)_table menuForTableColumn:(NSTableColumn *)_column row:(int)_row;

#pragma mark -
#pragma mark Download Commands

// these three are part of the HDDownloadCommands protocol
- (oneway void)ADDUPLOAD:(in NSArray *)data;
- (oneway void)CHGUPLOAD:(in NSArray *)data;
- (oneway void)DELUPLOAD:(in NSArray *)data;

// these two are not
- (void)ADDSOURCE:(NSArray *)data;
- (void)DELSOURCE:(NSArray *)data;


@end
