//
//  HDMainToolbarCategory.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDMainToolbarCategory.h"
#import "HDAspectControllerSearch.h"


@implementation HDMainController (HDMainToolbarCategory)

- (void)prepareToolbar
{
	if (!toolbarDefaultItems) {
		toolbarDefaultItems = [[NSArray alloc] initWithObjects:
			[NSArray arrayWithObjects:
				@"navigation", @"drawer",NSToolbarSeparatorItemIdentifier,
				@"DaemonConnection",NSToolbarFlexibleSpaceItemIdentifier,@"DaemonProcess",nil],
			[NSArray arrayWithObjects:
				@"navigation", @"drawer",NSToolbarSeparatorItemIdentifier,
				@"searchBrowse",/*@"iTMS",*/@"searchDownload",@"searchField",@"searchRealm",@"searchStop",nil],
			[NSArray arrayWithObjects:
				@"navigation", @"drawer",NSToolbarSeparatorItemIdentifier,
				@"downCancel",@"downPause",@"downResume",NSToolbarSeparatorItemIdentifier,
				@"downPreview",@"downDelSource",@"browseDownloadHost",NSToolbarSeparatorItemIdentifier,
				@"downClean",
				NSToolbarFlexibleSpaceItemIdentifier,@"downExpand",@"downCollapse",nil],
			[NSArray arrayWithObjects:
				@"navigation", @"drawer",NSToolbarSeparatorItemIdentifier,
				@"upCancel",
				@"browseUploadHost",NSToolbarSeparatorItemIdentifier,
				@"upClean",nil],
			nil];
	}
	NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
	if (![userDefaults objectForKey:@"MyToolbarItems"]) {
		// if not yet configured, set default items...
		[userDefaults setObject:toolbarDefaultItems forKey:@"MyToolbarItems"];
	}
	if (!toolbarAllowedItems) {
		toolbarAllowedItems = [[NSArray alloc] initWithObjects:
			[NSArray arrayWithObjects:
				//@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode",
				@"navigation", @"drawer",
				@"DaemonConnection",@"DaemonProcess",nil],
			[NSArray arrayWithObjects:
				//@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode",
				@"navigation", @"drawer",
				@"searchField",@"searchRealm",@"searchBrowse",@"searchDownload",@"searchStop",@"iTMS",nil],
			[NSArray arrayWithObjects:
				//@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode",
				@"navigation", @"drawer",
				@"downExpand",@"downCollapse",
				@"downPreview",@"downCancel",@"downPause",@"downResume",@"downDelSource",@"browseDownloadHost",@"downClean",nil],
			[NSArray arrayWithObjects:
				//@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode",
				@"navigation", @"drawer",
				@"upCancel",@"browseUploadHost",@"upClean",nil],
			[NSArray arrayWithObjects:NSToolbarFlexibleSpaceItemIdentifier,
								NSToolbarSpaceItemIdentifier,
								NSToolbarSeparatorItemIdentifier,
								nil],
			nil];
	}
	
	
	/*if (!toolbarSelectableItems) {
		toolbarSelectableItems = [[NSArray alloc] initWithObjects:
			//[NSArray arrayWithObjects:@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode", nil],
			//[NSArray arrayWithObjects:@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode", nil],
			//[NSArray arrayWithObjects:@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode", nil],
			//[NSArray arrayWithObjects:@"NetworksMode", @"SearchMode", @"DownloadsMode", @"UploadsMode", nil],
			nil];
	}*/

	NSToolbar *toolbar = [[NSToolbar alloc] initWithIdentifier:@"mainToolbar"];
	[toolbar setAllowsUserCustomization:YES];
	[toolbar setAutosavesConfiguration:YES];
	[toolbar setDelegate:self];
	[mainWindow setToolbar:toolbar];
	[toolbar release];
}

- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar *)toolbar
{
	NSArray *identifiers = nil;

	if ([self currentView]!=PZAspectPaneNone) {
		identifiers = [[NSArray arrayWithArray:[toolbarAllowedItems objectAtIndex:[self currentView]]]
				arrayByAddingObjectsFromArray:[toolbarAllowedItems objectAtIndex:4]
		];
	}
	
	return identifiers;
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar
{
	NSArray *identifiers = nil;
	
	if ([self currentView]!=PZAspectPaneNone) {
		identifiers = [toolbarDefaultItems objectAtIndex:currentView];
	}
	
	return identifiers;
}

/*- (NSArray *)toolbarSelectableItemIdentifiers:(NSToolbar *)toolbar {
	NSArray *identifiers = nil;
	//if (currentView != -1)
	//	identifiers = [toolbarSelectableItems objectAtIndex:currentView];
	return identifiers;
}*/

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar itemForItemIdentifier:(NSString *)itemIdentifier willBeInsertedIntoToolbar:(BOOL)flag
{
	NSToolbarItem *item = [[NSToolbarItem alloc] initWithItemIdentifier:itemIdentifier];
	[item setEnabled:NO];

	if ([itemIdentifier isEqualToString:@"navigation"]) {
		[item setLabel:@"Navigation"];
		[item setPaletteLabel:@"Navigation"];
		[item setView:modeControl];
		
		float width = [modeControl frame].size.width;
		[item setMinSize:NSMakeSize(width, 25)];
		[item setMaxSize:NSMakeSize(width, 32)];
		
		[item setEnabled:YES];
	}
	else if ([itemIdentifier isEqualToString:@"drawer"]) {
		[item setLabel:@"Drawer"];
		[item setPaletteLabel:@"Drawer"];
		[item setImage:[NSImage imageNamed:@"Drawer-List"]];
		//[item setView:drawerButton];
		//[item setMinSize:NSMakeSize(32,29)];
		//[item setMaxSize:NSMakeSize(32,32)];
		//[item setEnabled:YES];
		[item setToolTip:@"Toggle drawer"];
		[item setTarget:self];
		[item setAction:@selector(drawerAction:)];

	}
	else if ([itemIdentifier isEqualToString:@"DaemonConnection"]) {
		[item setLabel:@"Connection"];
		[item setPaletteLabel:@"Connection"];
		[item setToolTip:@"Connect to or disconnect from the giFT daemon"];
		[item setImage:[NSImage imageNamed:@"Green Ball"]];
		[item setTarget:daemonController];
		[item setAction:@selector(connectToLocalDaemon:)];
	}
	else if ([itemIdentifier isEqualToString:@"DaemonProcess"]) {
		[item setLabel:@"Daemon"];
		[item setPaletteLabel:@"Daemon"];
		[item setToolTip:@"Launch or terminate the giFT daemon"];
		[item setImage:[NSImage imageNamed:@"Power"]];
		[item setTarget:daemonController];
		[item setAction:@selector(launchDaemon:)];
	}
	else if ([itemIdentifier isEqualToString:@"searchField"]) {
		[item setLabel:@"Search"];
		[item setPaletteLabel:@"Search"];
		[item setView:[searchController toolbarSearchField]];
		[item setMinSize:NSMakeSize(100,25)];
		[item setMaxSize:NSMakeSize(2000,32)];
		[item setToolTip:@"Begin Search Here"];
		[item setEnabled:YES];

	}
	else if ([itemIdentifier isEqualToString:@"searchRealm"]) {
		[item setLabel:@"Realm"];
		[item setPaletteLabel:@"Realm"];
		
		id view = [searchController toolbarSearchRealmPopUpButton];
		[item setView:view];
		float width = [view frame].size.width;
		
		[item setMinSize:NSMakeSize(width, 25)];
		[item setMaxSize:NSMakeSize(width, 32)];
		[item setEnabled:YES];
	}
	else if ([itemIdentifier isEqualToString:@"searchDownload"]) {
		[item setLabel:@"Download"];
		[item setPaletteLabel:@"Download"];
		[item setImage:[NSImage imageNamed:@"Record"]];
		[item setTarget:searchController];
		[item setAction:@selector(download:)];
		[item setToolTip:@"Download selected item(s)"];
	}
	else if ([itemIdentifier isEqualToString:@"searchBrowse"]) {
		[item setLabel:@"Browse"];
		[item setPaletteLabel:@"Browse"];
		[item setImage:[NSImage imageNamed:@"Network Utility"]];
		[item setTarget:searchController];
		[item setAction:@selector(browse:)];
		[item setToolTip:@"View shared files of the selected user"];
	}
	else if ([itemIdentifier isEqualToString:@"searchStop"]) {
		[item setLabel:@"Toggle Search"];
		[item setPaletteLabel:@"Toggle Search"];
		[item setImage:[NSImage imageNamed:@"Spotlight"]];
		[item setTarget:searchController];
		[item setAction:@selector(toggleSelectedSearchStatus:)];
		[item setToolTip:@"Start or stop the currently viewed search"];
	}
	else if ([itemIdentifier isEqualToString:@"downCancel"]) {
		[item setLabel:@"Cancel"];
		[item setPaletteLabel:@"Cancel"];
		[item setImage:[NSImage imageNamed:@"Delete"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(cancelDownload:)];
		[item setToolTip:@"Cancel selected download(s)"];
	}
	else if ([itemIdentifier isEqualToString:@"downResume"]) {
		[item setLabel:@"Resume"];
		[item setPaletteLabel:@"Resume"];
		[item setImage:[NSImage imageNamed:@"reload"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(resumeDownload:)];
		[item setToolTip:@"Resume selected download(s)"];
	}
	else if ([itemIdentifier isEqualToString:@"downPause"]) {
		[item setLabel:@"Pause"];
		[item setPaletteLabel:@"Pause"];
		[item setImage:[NSImage imageNamed:@"Pause"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(pauseDownload:)];
		[item setToolTip:@"Pause selected download(s)"];
	}
	else if ([itemIdentifier isEqualToString:@"downDelSource"]) {
		[item setLabel:@"Cancel Source"];
		[item setPaletteLabel:@"Cancel Source"];
		[item setImage:[NSImage imageNamed:@"Remove"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(delsource:)];
		[item setToolTip:@"Cancel selected source(s)"];
	}
	else if ([itemIdentifier isEqualToString:@"browseDownloadHost"]) {
		[item setLabel:@"Browse Host"];
		[item setPaletteLabel:@"Browse Host"];
		[item setImage:[NSImage imageNamed:@"Network Utility"]];
		[item setTarget:self];
		[item setAction:@selector(browseDownloadHost:)];
		[item setToolTip:@"View shared files of the selected user"];
	}
	else if ([itemIdentifier isEqualToString:@"downClean"]) {
		[item setLabel:@"Clean Up"];
		[item setPaletteLabel:@"Clean Up"];
		[item setImage:[NSImage imageNamed:@"clean.tiff"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(cleanUpDownloads:)];
		[item setToolTip:@"Remove completed and cancelled downloads"];
	}
	else if ([itemIdentifier isEqualToString:@"downExpand"]) {
		[item setLabel:@"Expand All"];
		[item setPaletteLabel:@"Expand All"];
		[item setImage:[NSImage imageNamed:@"expand.tiff"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(expandAll:)];
		[item setToolTip:@"Expand all items"];
	}
	else if ([itemIdentifier isEqualToString:@"downCollapse"]) {
		[item setLabel:@"Collapse All"];
		[item setPaletteLabel:@"Collapse All"];
		[item setImage:[NSImage imageNamed:@"collapse.tiff"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(collapseAll:)];
		[item setToolTip:@"Collapse all items"];
	}
	else if ([itemIdentifier isEqualToString:@"upCancel"]) {
		[item setLabel:@"Cancel"];
		[item setPaletteLabel:@"Cancel"];
		[item setImage:[NSImage imageNamed:@"Delete"]];
		[item setTarget:uploadsController];
		[item setAction:@selector(cancelUpload:)];
		[item setToolTip:@"Cancel selected upload(s)"];
	}
	else if ([itemIdentifier isEqualToString:@"browseUploadHost"]) {
		[item setLabel:@"Browse Host"];
		[item setPaletteLabel:@"Browse Host"];
		[item setImage:[NSImage imageNamed:@"Network Utility"]];
		[item setTarget:self];
		[item setAction:@selector(browseUploadHost:)];
		[item setToolTip:@"View shared files of the selected user"];
	}
	else if ([itemIdentifier isEqualToString:@"upClean"]) {
		[item setLabel:@"Clean Up"];
		[item setPaletteLabel:@"Clean Up"];
		[item setImage:[NSImage imageNamed:@"clean.tiff"]];
		[item setTarget:uploadsController];
		[item setAction:@selector(cleanUpUploads:)];
		[item setToolTip:@"Remove completed and cancelled uploads"];
	}
	else if ([itemIdentifier isEqualToString:@"downPreview"]) {
		[item setLabel:@"Preview"];
		[item setPaletteLabel:@"Preview"];
		[item setImage:[NSImage imageNamed:@"Movies"]];
		[item setTarget:downloadsController];
		[item setAction:@selector(previewFile:)];
		[item setToolTip:@"Preview this download"];
	}
	else if ([itemIdentifier isEqualToString:@"iTMS"]) {
		[item setLabel:@"Buy"];
		[item setPaletteLabel:@"Buy"];
		[item setImage:[NSImage imageNamed:@"iTMS.tiff"]];
		[item setTarget:searchController];
		[item setAction:@selector(buyAtiTMS:)];
		[item setToolTip:@"Buy at the iTunes Music Store"];
	}
	return [item autorelease];
}

- (void)switchToolbarConfigurationTo:(int)conf
{
	NSToolbar *toolbar = [mainWindow toolbar];

	[self saveToolbarConfiguration];
	NSMutableDictionary *dict = [[toolbar configurationDictionary] mutableCopy];
	[dict setObject:[[[NSUserDefaults standardUserDefaults] arrayForKey:@"MyToolbarItems"] objectAtIndex:conf] forKey:@"TB Item Identifiers"];
	[toolbar setConfigurationFromDictionary:dict];
	[dict release];
	
	[self setCurrentView:conf];
}

- (void)saveToolbarConfiguration
{
	if ([self currentView] != PZAspectPaneNone) {
		NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
		NSMutableArray *conf = [NSMutableArray arrayWithArray:[userDefaults arrayForKey:@"MyToolbarItems"]];
		[conf replaceObjectAtIndex:[self currentView] withObject:[[[mainWindow toolbar] configurationDictionary] objectForKey:@"TB Item Identifiers"]];
		[userDefaults setObject:conf forKey:@"MyToolbarItems"];
	}
}

- (void)validateToolbar {
	[[mainWindow toolbar] validateVisibleItems];
}

@end
