//
// HDSearchFilterController.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDSearchResultSource.h"

@class SMDoubleSlider; 
@class HDFilterResultsSplitView;
@class PFilterView;


@interface HDSearchFilterController: NSObject
{
    IBOutlet NSButton *filterDisclosureTriangle;
    //IBOutlet NSButton *de_activate;
    IBOutlet NSTextField *info;
    IBOutlet NSTextField *keywordField;
    //IBOutlet NSView *sizeFilter;
    IBOutlet NSTextField *minText;
    IBOutlet NSTextField *maxText;
    IBOutlet NSTableView *protoTable;
    IBOutlet NSView *view;
    IBOutlet NSView *searches;
    
    NSMutableArray *AM_availableProtocols;
    HDSearchResultSource *datasource;
    int view_height;

    IBOutlet SMDoubleSlider	*_sm_horzSlider;
	
	IBOutlet NSView *filterView;
	//IBOutlet PFilterView *filterAddView;
	IBOutlet HDFilterResultsSplitView *filterSplitView;
	
	IBOutlet NSArrayController *filterProtocolListArrayController;
	
	float minimumHeight;
	float maximumHeight;

	NSString *AM_keywordFieldToolTip;
	NSString *AM_filterButtonToolTip;
}

- (id)init;
- (void)dealloc;
- (void)awakeFromNib;

- (void)disconnected;

- (void)prepareValues;

- (HDSearchResultSource *)searchDataSource;
- (void)setSearchDataSource:(HDSearchResultSource *)aResultSource;

- (void)noteAvailableProtocols:(NSNotification *)notification;
//- (void)setupSplitView:(NSNotification *)aNotification;

- (IBAction)toggleFilterDisclosureTriangle:(id)sender;
- (void)activate;

- (IBAction)changeFilterState:(id)sender;
- (IBAction)changeFilterKeyword:(id)sender;
- (IBAction)changeFilterProtocols:(id)sender;
- (IBAction)changeFilterSlider:(id)sender; 

@end

@interface HDSearchFilterController (Accessors)

- (NSString *)keywordFieldToolTip;
- (void)setKeywordFieldToolTip:(NSString *)aString;

- (NSString *)filterButtonToolTip;
- (void)setFilterButtonToolTip:(NSString *)aString;

- (NSMutableArray *)availableProtocols;
- (void)setAvailableProtocols:(NSArray *)anArray;

@end
