//
//  HDDaemonCommandDispatcher.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDDaemonCommandDispatcher.h"

const unsigned int HDDaemonCommandDispatcherNumberOfControllers = 4;	// [TODO] this probably breaks the MVC paradigm!

// [TODO][AM][MAJOR] note that changes from sel_getUid (which is the same as sel_registerName) to NSSelectorFromString *may* cause problems--I can't test yet as internet is down...

@implementation HDDaemonCommandDispatcher

- (id)init {
	if (self = [super init]) {
		controllers = [[NSMutableDictionary alloc] init];
		//registered=0;
	}
	return self;
}

- (void)dealloc
{
	[controllers release];
	controllers = nil;
	
	[super dealloc];
}


- (void)processOutput:(NSArray *)data
{
	if (data) {
		NSString *command;
		id controller;

		NSEnumerator *e = [data objectEnumerator];
		NSArray *parsed;
		
		while (parsed = [e nextObject]) {
			command = [parsed objectAtIndex:0];
			//NSLog(command);
			if (controller=[controllers objectForKey:command]) {
				//[controller performSelector:sel_getUid([[command stringByAppendingString:@":"] cString]) withObject:parsed];
				[controller performSelector:NSSelectorFromString([command stringByAppendingString:@":"]) withObject:parsed];
			}
			else {
				[[controllers objectForKey:@"REMOVE_UNKNOWN_COMMAND_TICKET"] performSelector:@selector(REMOVE_UNKNOWN_COMMAND_TICKET:) withObject:parsed];
			}
		}
		//[[controllers objectForKey:@"POISON_GUI_UPDATE"] performSelector:@selector(POISON_GUI_UPDATE:) withObject:nil];
	}
	return;
}

- (void)registerController:(id)controller forCommands:(NSArray *)command
{
	NSEnumerator *e = [command objectEnumerator];
	id obj;
	while (obj = [e nextObject]) {
		//[controller performSelector:sel_getUid([[obj stringByAppendingString:@":"] cString]) withObject:nil]; // dummy, doesn't work otherwise, WHY ???
		[controller performSelector:NSSelectorFromString([obj stringByAppendingString:@":"]) withObject:nil]; // dummy, doesn't work otherwise, WHY ???
		[controllers setObject:controller forKey:obj];
	}
	// [AM] removed "registered" variable, since NSDictionary supports the -count method
	// [AM] on the other hand, there exists no object for P_DO_SETUP in controllers,
	//		and no P_DO_SETUP: method, so let's just comment this out...
	/*if ([controllers count]==HDDaemonCommandDispatcherNumberOfControllers) {
		[[controllers objectForKey:@"P_DO_SETUP"] performSelector:@selector(P_DO_SETUP:) withObject:[NSNumber numberWithBool:YES]];
	}*/
}

@end
