// HDTransferSource.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>


// only the first four of these are used in HDTransferSourceUploads, but HDTransferSourceDownloads employs all of them
enum {
	HDTransferStatusCompleted	= 0,
	HDTransferStatusCanceled	= 1,
	HDTransferStatusPaused		= 2,
	HDTransferStatusActive		= 3,

	HDTransferStatusPausing		= 10,
	HDTransferStatusResuming	= 11,
};

@class PIconShop;


@interface HDTransferSource : NSObject {

	//NSTableColumn *selected_column;
	//BOOL sortAscending;
	//NSImage *ascending;
	//NSImage *descending;
	
	id table;

@protected
	PIconShop *iconShop;
	//SEL sorting_selector;
	
@private
	id giftCommander;
	
	NSMutableArray *AM_sourceArray;
	NSMutableDictionary *AM_ticketsDictionary;
}

- (id)init;
- (void)dealloc;

//- (id)commander;
//- (void)setCommander:(id)aCommander;

- (void)disconnected;

- (void)cleanUp:(id)sender;
- (int)transferSpeed;

- (NSString *)calcSize:(NSString *)size;

- (NSString *)stringForUsers:(int)users;
- (NSNumber *)transmit:(NSString *)_transmit total:(NSString *)_total;
- (NSString *)throughput:(NSString *)_throughput elapsed:(NSString *)_elapsed;
- (NSString *)timeStringFromInt:(int)sec;
- (NSString *)remainingWithTotalSize:(NSString *)_size transmit:(NSString *)_transmit throughput:(NSString *)_throughput elapsed:(NSString *)_elapsed;


#pragma mark -
#pragma mark Transfer Commands

- (void)DEL:(NSArray *)data;
- (void)reloadTableData:(void *)contextInfo;

#pragma mark -
#pragma mark Table and Outline View Hacks

// sorting ?
//- (void)cleanUpTableHeaders;
//- (void)setTableHeaders;


@end

#pragma mark -

@interface HDTransferSource (Accessors)

- (NSMutableArray *)sourceArray;
- (void)setSourceArray:(NSArray *)anArray;

- (NSMutableDictionary *)ticketsDictionary;
- (void)setTicketsDictionary:(NSDictionary *)aDictionary;

@end
