//
//  HDTransferSourceDownloads.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDTransferSource.h"


@class PDownloadsOutlineView;
@class PIconShop;
@class HDMusicIntegrationController;


@interface HDTransferSourceDownloads : HDTransferSource
{
	NSTreeController *downloadsTreeController;

	HDMusicIntegrationController *iTunesController;
	        
    // this set stores the hashes of active or paused downloads
    NSMutableSet *hashes;
	
	//HDDaemonCommander *commander;

    NSMenu *menu;
    
    // we use a dictionary to store the timers for 'auto find more sources'
    // key is the hash of the file
    //NSMutableDictionary *timers;
}

- (id)initWithTable:(PDownloadsOutlineView *)_table andTreeController:(NSTreeController *)aTreeController;

- (void)setHashes:(NSMutableSet *)_hashes;

//- (void)findMoreSourcesTimer:(NSTimer *)timer;
//- (void)findMoreSources:(NSString *)hash;

//- (int)numberOfDownloads;

- (NSString *)hashForTicket:(NSString *)ticket;

- (void)deleteEvent:(id)sender;
- (void)deleteSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (void)cancel:(id)commander;
- (void)pause:(id)commander;
- (void)resume:(id)commander;
- (void)delsource:(id)commander;
//- (void)browseHost:(id)commander;

- (void)expandAll;
- (void)collapseAll;
- (void)doDelete;

- (BOOL)validateDelSource;
- (BOOL)validateCancel;
- (BOOL)validatePause;
- (BOOL)validateResume;
- (BOOL)validateFindMoreSources;
- (BOOL)validatePreview;

- (void)createDockBadgeIcon;

- (void)moveFile:(id)thePath toFolder:(id)folderPath;

#pragma mark -
#pragma mark Download Commands

- (void)ADDDOWNLOAD:(NSArray *)data;
- (void)CHGDOWNLOAD:(NSArray *)data;

- (void)DELDOWNLOAD:(NSArray *)data;
//- (void)DEL:(NSArray *)data;

- (void)ADDSOURCE:(NSArray *)data;
- (void)DELSOURCE:(NSArray *)data;

@end

#pragma mark -

@interface HDTransferSourceDownloads (OverriddenMethods)
- (void)disconnected;
- (void)cleanUp:(id)sender;
- (void)reloadTableData:(void *)contextInfo;
@end
