//
//  HDTransferSourceUploads.h
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDTransferSource.h"


@class PUploadsTableView;
@class PIconShop;

@interface HDTransferSourceUploads : HDTransferSource {
}

- (id)initWithTable:(PUploadsTableView *)_table;

- (id)itemAtRow:(int)row;

//- (int)numberOfDownloads;

// respond to delete key...
- (void)deleteEvent:(id)sender;

- (void)cancel:(id)commander;
- (void)pause:(id)commander;
- (void)resume:(id)commander;
- (void)delsource:(id)commander;
//- (void)browseHost:(id)commander;

- (BOOL)validateDelSource;
- (BOOL)validateCancel;
- (BOOL)validatePause;
- (BOOL)validateResume;

#pragma mark -
#pragma mark Upload Commands

- (void)ADDUPLOAD:(NSArray *)data;
- (void)CHGUPLOAD:(NSArray *)data;

- (void)DELUPLOAD:(NSArray *)data;
//- (void)DEL:(NSArray *)data;

- (void)ADDSOURCE:(NSArray *)data;
- (void)DELSOURCE:(NSArray *)data;

@end


@interface HDTransferSourceUploads (OverriddenMethods)
- (void)disconnected;
- (void)cleanUp:(id)sender;
- (void)reloadTableData:(void *)contextInfo;
@end
