//
//  HDTransferSourceUploads.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDTransferSourceUploads.h"
#import "PUploadTitleDescriptionCell.h"
#import "PIconShop.h"
#import "HDDaemonCommander.h"
#import "HDTransferSourceEntry.h"


@implementation HDTransferSourceUploads

- (id)initWithTable:(PUploadsTableView *)_table
{
	if (self = [super init]) {
		table = _table;
	}
	return self;
}

- (id)itemAtRow:(int)row
{
	return [[self sourceArray] objectAtIndex:row];
}

- (BOOL)validateDelSource
{
/*    if ([table numberOfSelectedRows]<=0) return NO;
	NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	while (num=[enumerator nextObject]) {
		if ([[[table itemAtRow:[num intValue]] objectForKey:@"PExpandable"] boolValue]) return NO;
	}*/
	return YES;
}

- (BOOL)validateCancel
{
	BOOL isValidated = NO;

	if ([table numberOfSelectedRows]>0) {
		isValidated = YES;
		NSEnumerator *enumerator = [table selectedRowEnumerator];
		NSNumber *num;
		NSDictionary *tmp;
		while (num=[enumerator nextObject]) {
			tmp = [[self sourceArray] objectAtIndex:[num intValue]];
			if (/*![[tmp objectForKey:@"PExpandable"] boolValue] ||*/ ([[tmp objectForKey:HDTransferSourcePStatusKey] intValue]<=1) ) {
				isValidated = NO;
				break;
			}
		}
	}

	return isValidated;
}

- (BOOL)validatePause
{
	/*if ([table numberOfSelectedRows]<=0) return NO;
	NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	NSDictionary *tmp;
	while (num=[enumerator nextObject]) {
		tmp = [table itemAtRow:[num intValue]];
		if (![[tmp objectForKey:@"PExpandable"] boolValue] || [[tmp objectForKey:HDTransferSourcePStatusKey] intValue] != HDTransferStatusActive) return NO;
	}*/
	return YES;
}

- (BOOL)validateResume
{
/*    if ([table numberOfSelectedRows]<=0) return NO;
	NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	NSDictionary *tmp;
	while (num=[enumerator nextObject]) {
		tmp = [table itemAtRow:[num intValue]];
		if (![[tmp objectForKey:@"PExpandable"] boolValue] || [[tmp objectForKey:HDTransferSourcePStatusKey] intValue] != HDTransferStatusPaused) return NO;
	}*/
	return YES;
}

- (void)deleteEvent:(id)sender
{
	// this array stores the tickets of the deleted downloads
	// so we don't have to delete their sources, if they are selected too
	NSMutableArray *deletedUploads = [[NSMutableArray alloc] init];
		
	// we store all commands in one string, and send it at once
	NSMutableString *tmpcmd = [[NSMutableString alloc] initWithString:@""];
	
	NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	NSMutableDictionary *item;
	while (num=[enumerator nextObject]) {
		item = [[self sourceArray] objectAtIndex:[num intValue]];
		[deletedUploads addObject:[item objectForKey:HDTransferSourcePTicketKey]];
		if ([[item objectForKey:HDTransferSourcePStatusKey] intValue]>1) {
			[deletedUploads addObject:[item objectForKey:HDTransferSourcePTicketKey]];
			[tmpcmd appendString:[NSString stringWithFormat:@";\nTRANSFER(%@) action(cancel)",[item objectForKey:HDTransferSourcePTicketKey]]];
		}
	}
	
	// now we just have to remove the deleted uploads from the table
	NSEnumerator *e = [deletedUploads objectEnumerator];
	NSString *ticket;
	while (nil != (ticket = [e nextObject])) {
		[[self sourceArray] removeObject:[[self ticketsDictionary] objectForKey:ticket]];
		[[self ticketsDictionary] removeObjectForKey:ticket];	// ticket, not tickets, right? TYPO IN ORIGINAL
	}
	[table reloadData];
	if ([tmpcmd length]>2) [[HDDaemonCommander sharedInstance] performSelector:@selector(executeCommand:) withObject:[tmpcmd substringFromIndex:2]];

	[deletedUploads release];
	[tmpcmd release];
}

- (void)cancel:(id)commander
{
	NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	NSMutableDictionary *item;
	while (num=[enumerator nextObject]) {
		item = [[self sourceArray] objectAtIndex:[num intValue]];
		[commander performSelector:@selector(executeCommand:) withObject:[NSString stringWithFormat:@"TRANSFER(%@) action(cancel)",[item objectForKey:HDTransferSourcePTicketKey]]];
		[item setObject:[NSNumber numberWithInt:HDTransferStatusCanceled] forKey:HDTransferSourcePStatusKey];
		[item setObject:[NSMutableArray arrayWithObjects:
			[NSNumber numberWithBool:YES],
			[NSNumber numberWithBool:NO],
			@"Cancelling...",nil]
		forKey:HDTransferSourcePProgressKey];
		[table reloadData];
	}
}

- (void)pause:(id)commander
{
   /* NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	while (num=[enumerator nextObject]) {
		[commander executeCommand:[NSString stringWithFormat:@"TRANSFER(%@) action(pause)",[[table itemAtRow:[num intValue]] objectForKey:HDTransferSourcePTicketKey]]];
	}*/
}

- (void)resume:(id)commander
{
   /* NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	while (num=[enumerator nextObject]) {
		[commander executeCommand:[NSString stringWithFormat:@"TRANSFER(%@) action(unpause)",[[table itemAtRow:[num intValue]] objectForKey:HDTransferSourcePTicketKey]]];
	}*/
}

- (void)delsource:(id)commander
{
	/*NSEnumerator *enumerator = [table selectedRowEnumerator];
	NSNumber *num;
	NSDictionary *tmp;
	NSString *tmpcmd=@"";
	while (num=[enumerator nextObject]) {
		tmp = [table itemAtRow:[num intValue]];
		if (![[tmp objectForKey:@"PExpandable"] boolValue])
			tmpcmd = [tmpcmd stringByAppendingString:[NSString stringWithFormat:@"\n;DELSOURCE(%@) url(%@)",[tmp objectForKey:HDTransferSourcePTicketKey],[tmp objectForKey:@"url"]]];
	}
	[commander executeCommand:[tmpcmd substringFromIndex:2]];*/
}

/*- (void)browseHost:(id)commander
{
	//[commander executeCommand:[table itemAtRow:[table selectedRow]]
}*/

/*- (void)expand
{
	int i, count=[source count];
	for (i=0;i<count;i++) [table expandItem:[source objectAtIndex:i]];
}

- (void)collapse
{
	int i, count=[source count];
	for (i=0;i<count;i++) [table collapseItem:[source objectAtIndex:i]];
}*/

/*- (int)numberOfDownloads
{
	return [source count];
}*/

#pragma mark -
#pragma mark Table View Methods

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return [[self sourceArray] count];
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	return [[[self sourceArray] objectAtIndex:rowIndex] objectForKey:[aTableColumn identifier]];;
}

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectTableColumn:(NSTableColumn *)aTableColumn
{
	return NO;
}

// a delegate method
- (void)tableView:(NSTableView *)aTableView willDisplayCell:(id)aCell 
	forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	NSString *identifier = [aTableColumn identifier];

	if ([identifier isEqualToString:@"PFileUser"]) {
		BOOL shouldHighlight = ([[aTableView selectedRowIndexes] containsIndex:rowIndex] && [[NSApp mainWindow] firstResponder] == aTableView);
		NSAttributedString *attributedString = [aCell generatedAttributedStringWithHighlight:shouldHighlight];
		[aCell setAttributedStringValue:attributedString];
	} else if ([identifier isEqualToString:@"PTransfer"] || [identifier isEqualToString:@"PSize"]) {
		BOOL shouldHighlight = ([[aTableView selectedRowIndexes] containsIndex:rowIndex] && [[NSApp mainWindow] firstResponder] == aTableView);
		NSAttributedString *attributedString = [aCell generatedAttributedStringWithHighlight:shouldHighlight];
		[aCell setAttributedStringValue:attributedString];
	}
}

#pragma mark -
#pragma mark Upload Commands

- (void)ADDUPLOAD:(NSArray *)data
{
	NSString *ticket = [data objectAtIndex:1];
	if ([ticket intValue] > 0) {	// [CHANGED] != 0?
		NSMutableDictionary *dict = [data objectAtIndex:2];
		
		//[dict setObject:[NSNumber numberWithBool:YES] forKey:@"PExpandable"];
		[dict setObject:ticket forKey:HDTransferSourcePTicketKey];
		[dict setObject:[iconShop iconForFileType:[[dict objectForKey:@"file"] pathExtension]] forKey:@"PIcon"];
		[dict setObject:[NSMutableArray arrayWithObjects:
			[NSNumber numberWithBool:YES],
			[dict objectForKey:@"file"],
			@"",nil]
			forKey:@"PFileUser"
		];
		[dict setObject:[NSMutableArray arrayWithObjects:
					[NSNumber numberWithBool:YES],
					@"",
					[NSString stringWithFormat:@"of %@",[self calcSize:[dict objectForKey:@"size"]]],
				nil]
			forKey:@"PSize"];
			
		if ([[dict objectForKey:@"state"] isEqualToString:@"Paused"])
			[dict setObject:[NSNumber numberWithInt:HDTransferStatusPaused] forKey:HDTransferSourcePStatusKey];
		else
			[dict setObject:[NSNumber numberWithInt:HDTransferStatusActive] forKey:HDTransferSourcePStatusKey];
		[dict setObject:[NSMutableDictionary dictionary] forKey:@"PSources"];
		
		[[self sourceArray] addObject:dict];
		[[self ticketsDictionary] setObject:dict forKey:ticket];
		[table reloadData];
		[self CHGUPLOAD:data];
	}
}

- (void)CHGUPLOAD:(NSArray *)data
{
	NSString *ticket = [data objectAtIndex:1];
	if (ticket) {
		
		NSMutableDictionary *item	= [[self ticketsDictionary] objectForKey:ticket];			// already saved item...
		
		NSMutableDictionary *new	= [data objectAtIndex:2];
		NSMutableArray *sources	= [data objectAtIndex:3];				// new sources...
		int i,sourcescount		= [sources count];
		
		NSString *state		= [new objectForKey:@"state"];
		
		NSMutableDictionary *tmp;
		NSString *tmpstring;
		
		if ([[item objectForKey:HDTransferSourcePStatusKey] intValue] <= HDTransferStatusCanceled) return;	// HDTransferStatusCanceled OR HDTransferStatusCompleted
		
		NSMutableArray *tmpsrc = [NSMutableArray array];
		for (i=0;i<sourcescount;i++) {
			tmp = [[sources objectAtIndex:i] objectAtIndex:2];
			[tmp setObject:ticket forKey:HDTransferSourcePTicketKey];
			[tmpsrc addObject:tmp];
		}
		[item setObject:tmpsrc forKey:@"PSources"];

		if (sourcescount>0) {
			NSScanner *scanner = [NSScanner scannerWithString:[[[sources objectAtIndex:0] objectAtIndex:2] objectForKey:@"url"]];
			[scanner scanUpToString:@":" intoString:&tmpstring];
			tmpstring = [tmpstring stringByAppendingString:@" - "];
			[[item objectForKey:@"PFileUser"] replaceObjectAtIndex:2 withObject:
				[NSString stringWithFormat:@"%@%@",tmpstring,[[[sources objectAtIndex:0] objectAtIndex:2] objectForKey:@"user"]]];
		}
		

		if ([state isEqualToString:@"Completed"]) { // clean up completed downloads...
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],[NSNumber numberWithBool:NO],@"Completed",nil] forKey:HDTransferSourcePProgressKey];
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],@"",@"",nil] forKey:@"PTransfer"];
			[[item objectForKey:@"PSize"] replaceObjectAtIndex:1 withObject:[self calcSize:[item objectForKey:@"size"]]];
			[item setObject:[NSNumber numberWithInt:HDTransferStatusCompleted] forKey:HDTransferSourcePStatusKey];
			for (i=0;i<sourcescount;i++) {
				tmp = [[sources objectAtIndex:i] objectAtIndex:2];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],[tmp objectForKey:@"user"],nil] forKey:@"PFileUser"];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],[NSNumber numberWithBool:NO],@"",nil]
					forKey:HDTransferSourcePProgressKey];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],@"",nil]
					forKey:@"PTransfer"];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],@"",nil]
					forKey:@"PSize"];
			}
			[table reloadData];
			return;
		}
		else if ([state isEqualToString:@"Paused"]) {
			[item setObject:[NSNumber numberWithInt:HDTransferStatusPaused] forKey:HDTransferSourcePStatusKey];
			if (tmpstring=[new objectForKey:@"transmit"])
				[[item objectForKey:@"PSize"] replaceObjectAtIndex:1 withObject:[self calcSize:tmpstring]];
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],@"",@"",nil] forKey:@"PTransfer"];
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],[NSNumber numberWithBool:NO],@"Paused",nil] forKey:HDTransferSourcePProgressKey];
			for (i=0;i<sourcescount;i++) {
				tmp = [[sources objectAtIndex:i] objectAtIndex:2];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],[tmp objectForKey:@"user"],nil] forKey:@"PFileUser"];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],[NSNumber numberWithBool:NO],@"",nil]
					forKey:HDTransferSourcePProgressKey];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],@"",nil]
					forKey:@"PTransfer"];
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],@"",nil]
					forKey:@"PSize"];
			}
			[table reloadData];
			return;
		}
		else [item setObject:[NSNumber numberWithInt:HDTransferStatusActive] forKey:HDTransferSourcePStatusKey];
		
		BOOL downloading=NO;
		for (i=0;i<sourcescount;i++) {
			tmp = [[sources objectAtIndex:i] objectAtIndex:2];
			tmpstring = [tmp objectForKey:@"status"];
			if ([tmpstring isEqualToString:@"Active"]) {
				downloading=YES;
				[tmp setObject:[NSArray arrayWithObjects:
						[NSNumber numberWithBool:NO],
						[NSNumber numberWithBool:YES],
						[self transmit:[tmp objectForKey:@"transmit"] total:[tmp objectForKey:@"total"]],nil]
					forKey:HDTransferSourcePProgressKey];
			}
			else {
				[tmp setObject:[NSArray arrayWithObjects:
						[NSNumber numberWithBool:NO],
						[NSNumber numberWithBool:NO],
						tmpstring,nil]
					forKey:HDTransferSourcePProgressKey];
			}
			
			if (tmpstring=[tmp objectForKey:@"transmit"]) {
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],
						[NSString stringWithFormat:@"%@ of %@",[self calcSize:tmpstring],[self calcSize:[tmp objectForKey:@"total"]]],nil]
					forKey:@"PSize"];
			}
			else {
				[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],@"",nil] forKey:@"PSize"];
			}
			[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],@"",nil] forKey:@"PTransfer"];
			[tmp setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:NO],[tmp objectForKey:@"user"],nil] forKey:@"PFileUser"];
		}
		NSString *transmit		= [new objectForKey:@"transmit"];
		[[item objectForKey:@"PSize"] replaceObjectAtIndex:1 withObject:[self calcSize:transmit]];
		if (downloading) {
			NSString *size		= [new objectForKey:@"size"];
			NSString *transmit	= [new objectForKey:@"transmit"];
			NSString *throughput	= [new objectForKey:@"throughput"];
			NSString *elapsed	= [new objectForKey:@"elapsed"];
			
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],[NSNumber numberWithBool:YES],[self transmit:transmit total:size],nil] forKey:HDTransferSourcePProgressKey];
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],[self throughput:throughput elapsed:elapsed],[self remainingWithTotalSize:size transmit:transmit throughput:throughput elapsed:elapsed],nil]
				forKey:@"PTransfer"];
		}
		else {
			if ([[new objectForKey:@"state"] isEqualToString:@"Active"])
				[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],[NSNumber numberWithBool:NO],@"Waiting",nil] forKey:HDTransferSourcePProgressKey];
			else
				[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],[NSNumber numberWithBool:NO],[new objectForKey:@"state"],nil] forKey:HDTransferSourcePProgressKey];
			[item setObject:[NSArray arrayWithObjects:[NSNumber numberWithBool:YES],@"",@"",nil]
				forKey:@"PTransfer"];
		}
		if (transmit) {
			[[item objectForKey:@"PSize"] replaceObjectAtIndex:1 withObject:[self calcSize:transmit]];
		}
		
		[table reloadData];
	}
}


- (void)DELUPLOAD:(NSArray *)data
{
	NSString *ticket = [data objectAtIndex:1];
	if (ticket) {
		NSMutableDictionary *item = [[self ticketsDictionary] objectForKey:ticket];
		
		// it's possible that we already removed the upload from the table
		// if the user cancelled with delete key
		if (item) {
			if ([[item objectForKey:HDTransferSourcePStatusKey] intValue] == HDTransferStatusCompleted) {
				if ([[NSUserDefaults standardUserDefaults] boolForKey:@"HDUploadsRemoveCompleted"]) {
					[[self sourceArray] removeObject:[[self ticketsDictionary] objectForKey:ticket]];
					[[self ticketsDictionary] removeObjectForKey:ticket];	// typo: key originally the variable tickets
					[table reloadData];
				}
				
			} else {
				if ([[NSUserDefaults standardUserDefaults] boolForKey:@"HDUploadsRemoveCanceled"]) {
					[[self sourceArray] removeObject:[[self ticketsDictionary] objectForKey:ticket]];
					[[self ticketsDictionary] removeObjectForKey:ticket];	// typo: key originally the variable tickets
					[table reloadData];
				}
				else {
					[self DEL:data];
				}
			}
		}
	}
}


- (void)ADDSOURCE:(NSArray *)data
{
//[new setObject:[NSNumber numberWithBool:NO] forKey:@"PExpandable"];	// [TODO] is this the rgiht place? [AM]
}

- (void)DELSOURCE:(NSArray *)data
{
	/*NSString *ticket	= [data objectAtIndex:1];
	NSString *url	= [[data objectAtIndex:2] objectForKey:@"url"];
	if (!ticket || !url) return;
	NSMutableArray *sources = [[tickets objectForKey:ticket] objectForKey:@"PSources"];
	int i, count = [sources count];
	for (i=0;i<count;i++) {
		if ([[[sources objectAtIndex:i] objectForKey:@"url"] isEqualToString:url]) {
			[sources removeObjectAtIndex:i];
		}
	}
	count = [sources count];
	[[[tickets objectForKey:ticket] objectForKey:@"PFileUser"] replaceObjectAtIndex:2 withObject:[self stringForUsers:count]];
	[table reloadData];*/
}

- (void)DEL:(NSArray *)data
{
	[super DEL:data];

	NSString *ticket = [data objectAtIndex:1];
	if (ticket) {
		NSMutableDictionary *item = [[self ticketsDictionary] objectForKey:ticket];
		if ([[item objectForKey:@"PStatus"] intValue] != HDTransferStatusCompleted) {
			// download was cancelled...
			
			NSNumber *yesValue = [NSNumber numberWithBool:YES];
			NSNumber *noValue = [NSNumber numberWithBool:NO];
						
			[item setObject:[NSNumber numberWithInt:HDTransferStatusCanceled] forKey:@"PStatus"];
			[item setObject:[NSArray arrayWithObjects:yesValue,[NSNumber numberWithBool:NO],@"Cancelled",nil] forKey:@"PProgress"];
			[item setObject:[NSArray arrayWithObjects:yesValue,@"",@"",nil] forKey:@"PTransfer"];
			[item setObject:[NSArray arrayWithObjects:yesValue,@"",@"",nil] forKey:@"PSize"];
			
			NSMutableArray *sources = [item objectForKey:@"PSources"];
			NSEnumerator *e = [sources objectEnumerator];
			NSMutableDictionary *tmp;
			
			while (nil != (tmp = [e nextObject])) {
				[tmp setObject:[NSArray arrayWithObjects:noValue,[NSNumber numberWithBool:NO],@"",nil] forKey:@"PProgress"];
				[tmp setObject:[NSArray arrayWithObjects:noValue,@"",nil] forKey:@"PTransfer"];
				[tmp setObject:[NSArray arrayWithObjects:noValue,@"",nil] forKey:@"PSize"];
			}
			[self reloadTableData:(void *)item];
		}
	}
}

@end

#pragma mark -

@implementation HDTransferSourceUploads (OverriddenMethods)

- (void)disconnected {
	[super disconnected];
	[table reloadData];
}

- (void)cleanUp:(id)commander {
	[super cleanUp:commander];
	[table reloadData];
}

- (void)reloadTableData:(void *)contextInfo {
	[table reloadData];
}

@end