//
// PPrefDownloads.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDPreferencesAspectDaemon.h"
#import "HDPreferencesConfigurationEditorGiFT.h"
#import "HDPreferencesConfigurationEditorUI.h"


@implementation HDPreferencesAspectDaemon

- (id)init {
	if (nil != (self = [super init])) {
		if (![NSBundle loadNibNamed:@"PreferencePaneDaemon" owner:self]) {
			[self release];
			self = nil;
		}
	}
	return self;
}

- (void)awakeFromNib
{
	[self readConfFiles];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(noteConfigurationFilesUpdated:) name:@"PUpdateFromConfFiles" object:nil];
}

- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	[super dealloc];
}

- (BOOL)isInterfaceEnabled {
	return AM_interfaceEnabled;
}

- (void)setInterfaceEnabled:(BOOL)flag {
	AM_interfaceEnabled = flag;
}

- (void)noteConfigurationFilesUpdated:(NSNotification *)aNotification {
	[self readConfFiles];
}

- (void)readConfFiles
{
	if (!gift_conf) gift_conf=[HDPreferencesConfigurationEditorGiFT singleton];
	if (!ui_conf) ui_conf = [HDPreferencesConfigurationEditorUI singleton];
	if ( (ui_conf = [HDPreferencesConfigurationEditorUI singleton]) && (gift_conf = [HDPreferencesConfigurationEditorGiFT singleton]) ) {
		[self setInterfaceEnabled:YES];
			
		[ui_conf read];
		[gift_conf read];
		
		//[port setIntValue:[[ui_conf optionValueForKey:@"port"] intValue]];	// [TODO] do we need this?
		[addressTextField setStringValue:[ui_conf optionValueForKey:@"host"]];
	}
	else {
		[self setInterfaceEnabled:NO];
	}
}

/*- (IBAction)addressChanged:(id)sender
{
}*/

/*- (void)hello {
	NSLog(@"world!");
}*/

- (IBAction)portChanged:(id)sender
{
    int p = [sender intValue];
    [[NSUserDefaults standardUserDefaults] setInteger:p forKey:@"HDDaemonPort"];
    [gift_conf setValue:[NSNumber numberWithInt:p] forKey:@"client_port"];
    [ui_conf setValue:[NSNumber numberWithInt:p] forKey:@"port"];
    [self readConfFiles];
}

- (IBAction)customDaemonStateChanged:(id)sender
{
	// read from the conf files
	[[NSNotificationCenter defaultCenter]
		postNotificationName:@"PUpdateFromConfFiles" 
		object:self
		userInfo:nil];
}

/*- (void)setNilValueForKey:(NSString *)key {
	
}*/

@end
