//
// PPrefDownloads.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDPreferencesAspectPlugIns.h"
#import "HDPreferencesConfigurationEditorGiFT.h"


@implementation HDPreferencesAspectPlugIns

- (id)init {
	if (nil != (self = [super init])) {
		if (![NSBundle loadNibNamed:@"PreferencePanePlugIns" owner:self]) {
			[self release];
			self = nil;
		}
	}
	return self;
}

- (void)awakeFromNib
{
	[self readConfFiles];

	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(noteConfigurationFilesUpdated:) name:@"PUpdateFromConfFiles" object:nil];

}

- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	if (plugins) [plugins release];
	
	[super dealloc];
}

/*- (void)enable
{
	[buttonOpenFT setEnabled:YES];
	[buttonGnutella setEnabled:YES];
	[buttonFastTrack setEnabled:YES];
	[buttonAres setEnabled:YES];
}

- (void)disable
{
	[buttonOpenFT setEnabled:NO];
	[buttonGnutella setEnabled:NO];
	[buttonFastTrack setEnabled:NO];
	[buttonAres setEnabled:NO];
}*/

- (BOOL)isInterfaceEnabled {
	return AM_interfaceEnabled;
}

- (void)setInterfaceEnabled:(BOOL)flag {
	AM_interfaceEnabled = flag;
}

- (void)noteConfigurationFilesUpdated:(NSNotification *)aNotification {
	[self readConfFiles];
}

- (void)readConfFiles
{
	if (gift_conf=[HDPreferencesConfigurationEditorGiFT singleton]) {
		[self setInterfaceEnabled:YES];
		
		[gift_conf read];

		//plugins = [[NSMutableArray alloc] init];

		plugins = [[gift_conf optionValueForKey:@"plugins"] mutableCopy];

		if ([plugins containsObject:@"OpenFT"])
			[buttonOpenFT setState:NSOnState];
		if ([plugins containsObject:@"Gnutella"])
			[buttonGnutella setState:NSOnState];
		if ([plugins containsObject:@"FastTrack"])
			[buttonFastTrack setState:NSOnState];
		if ([plugins containsObject:@"Ares"])
			[buttonAres setState:NSOnState];

	}
	else {
		[self setInterfaceEnabled:NO];
	}
}

- (IBAction)buttonOpenFTChanged:(id)sender
{
	if (![plugins containsObject:@"OpenFT"]) {
		[plugins addObject:@"OpenFT"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
	else {
		[plugins removeObject:@"OpenFT"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
		
}

- (IBAction)buttonGnutellaChanged:(id)sender
{
	if (![plugins containsObject:@"Gnutella"]) {
		[plugins addObject:@"Gnutella"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
	else {
		[plugins removeObject:@"Gnutella"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
}

- (IBAction)buttonAresChanged:(id)sender
{
	if (![plugins containsObject:@"Ares"]) {
		[plugins addObject:@"Ares"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
	else {
		[plugins removeObject:@"Ares"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
}

- (IBAction)buttonFastTrackChanged:(id)sender
{
	if (![plugins containsObject:@"FastTrack"]) {
		[plugins addObject:@"FastTrack"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
	else {
		[plugins removeObject:@"FastTrack"];
		NSMutableArray *tmp = [plugins mutableCopy];
		[gift_conf setOptionValue:tmp forKey:@"plugins"];
		[tmp release];
	}
}

@end
