//
// PPrefDownloads.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import <Cocoa/Cocoa.h>
#import "HDPreferencesAspect.h"

@class AMTableView;
@class HDPreferencesConfigurationEditorGiFT;


@interface HDPreferencesAspectUploads : HDPreferencesAspect {
	IBOutlet NSArrayController *arrayController;


	//IBOutlet NSButton *removeCancelled;
	//IBOutlet NSButton *removeCompleted;
	IBOutlet AMTableView *shareTable;
	//IBOutlet NSButton *removeButton;
	//IBOutlet NSButton *addButton;
	
	IBOutlet NSTextField *maxUploads;
	IBOutlet NSTextField *maxPerUser;
	IBOutlet NSTextField *maxUpstream;
	IBOutlet NSTextField *maxDownstream;
	
	//NSUserDefaults *userDefaults;
	HDPreferencesConfigurationEditorGiFT *gift_conf;
	
	NSMutableArray *AM_shareSourceArray;
	
	BOOL share_completed;
	
	BOOL AM_interfaceEnabled;
	
	
	NSSortDescriptor *pathSortDescriptor;
}

- (id)init;

- (void)noteConfigurationFilesUpdated:(NSNotification *)aNotification;
- (void)readConfFiles;

//- (IBAction)cancelledPrefsChanged:(id)sender;
//- (IBAction)completedPrefsChanged:(id)sender;
- (void)noteShareAdded:(NSNotification *)aNotification;
- (void)noteShareRemoved:(NSNotification *)aNotification;
- (IBAction)maxUploadsChanged:(id)sender;
- (IBAction)maxPerUserChanged:(id)sender;
- (IBAction)maxUploadSpeedChanged:(id)sender;
- (IBAction)maxDownloadSpeedChanged:(id)sender;

- (void)completedDirectoryChanged:(NSNotification *)notification;

//- (NSArray *)pathSortDescriptors;
//- (void)setPathSortDescriptors:(NSArray *)anArray;

@end

@interface HDPreferencesAspectUploads (Accessors)

- (NSMutableArray *)shareSourceArray;
- (void)setShareSourceArray:(NSArray *)anArray;

- (BOOL)isInterfaceEnabled;
- (void)setInterfaceEnabled:(BOOL)flag;

@end
