//
//  HDPreferencesConfigurationEditorFastTrack.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDPreferencesConfigurationEditorFastTrack.h"

static HDPreferencesConfigurationEditorFastTrack *singleton;

@implementation HDPreferencesConfigurationEditorFastTrack

+ (id)singleton
{
	id theSingleton = nil;
	
	if (!singleton) {
		singleton = [[[self class] alloc] init];
	}
	if (singleton) {
		BOOL test = [[NSFileManager defaultManager] fileExistsAtPath:[singleton path]];
		if (test) {
			theSingleton = singleton;
		}
	}
	else {
		NSLog(@"FastTrack.conf not found");
	}
	
	return theSingleton;
}

- (NSString *)path
{
	return [[[[self class] pathToDaemon]
				stringByAppendingPathComponent:@"FastTrack"]
				stringByAppendingPathComponent:@"FastTrack.conf"];
}

- (id)init
{
	if (self = [super init]) {
		int_confs = [[NSArray alloc] initWithObjects:
			@"forwarding",
			@"allow_sharing",
			@"banlist_filter",
			@"port",
			nil];
		
		string_confs = [[NSArray alloc] initWithObjects:
			@"alias",
			nil];
		colon_confs = [[NSArray alloc] init];
		space_confs = [[NSArray alloc] init];
	}
	return self;
}

- (void)dealloc
{
	[int_confs release];
	[string_confs release];
	[colon_confs release];
	[space_confs release];
	[super dealloc];
}

@end
