//
//  HDPreferencesConfigurationEditorGiFT.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDPreferencesConfigurationEditorGiFT.h"

static HDPreferencesConfigurationEditorGiFT *singleton = nil;

@implementation HDPreferencesConfigurationEditorGiFT

+ (id)singleton
{
	id theSingleton = nil;
	
	if (!singleton) {
		singleton = [[[self class] alloc] init];
	}
	if (singleton) {
		BOOL test = [[NSFileManager defaultManager] fileExistsAtPath:[singleton path]];
		if (test) {
			theSingleton = singleton;
		}
	}
    else {
        NSLog(@"giftd.conf not found");
    }
	
	return theSingleton;
}

/*+ (NSString *)giFThomeTempForPathToDaemon
{
	NSString *string;
    if ([[NSUserDefaults standardUserDefaults] boolForKey:@"PUseCustomDaemon"])
        string = [NSHomeDirectory() stringByAppendingPathComponent:@".giFT"];
    else
        string = [[[NSHomeDirectory() 
                    stringByAppendingPathComponent:@"Library"]
                    stringByAppendingPathComponent:@"Application Support"]
                    stringByAppendingPathComponent:@"Poisoned"];
	
	//NSLog(@"string = %@", string);
	//NSLog(@"appsupp = %@", HDApplicationSupportDirectory());
	return string;
}*/


- (NSString *)path {
	return [[[self class] pathToDaemon] stringByAppendingPathComponent:@"giftd.conf"];
}

- (id)init
{
	if (self = [super init]) {
		int_confs = [[NSArray alloc] initWithObjects:
			@"setup",
			@"client_port",
			@"follow_symlinks",
			@"max_peruser_uploads",
			@"hide_dot_files",
			@"max_uploads",
			@"auto_resync_interval",
			@"share_completed",
			@"downstream",
			@"upstream",
			nil];
		string_confs = [[NSArray alloc] initWithObjects:
			@"incoming",
			@"completed",
			nil];
		colon_confs = [[NSArray alloc] initWithObjects:
			@"plugins",
			@"root",
			nil];
		space_confs = [[NSArray alloc] initWithObjects:
			@"hosts_allow",
			nil];
	}
	return self;
}

- (void)dealloc
{	
	[int_confs release];
	[string_confs release];
	[colon_confs release];
	[space_confs release];
	[super dealloc];
}

- (void)setup
{
	NSLog(@"Calling -[HDPreferencesConfigurationEditorGiFT setup]...");
	[self setOptionValue:[NSNumber numberWithInt:1] forKey:@"setup"];
}

- (void)restoreOldPrefs
{
	NSString *oldPrefFile = [[[self class] pathToDaemon] stringByAppendingPathComponent:@"gift.conf"];
	
	// if there's no gift.conf file we don't have to do anything...
	if ([[NSFileManager defaultManager] fileExistsAtPath:oldPrefFile]) {
	
		NSLog(@"saving old prefs from gift.conf into giftd.conf");

		NSString *path = [[[self class] pathToDaemon] stringByAppendingPathComponent:@"gift.conf"];
		NSString *content = [[NSString alloc] initWithContentsOfFile:path encoding:NSUTF8StringEncoding error:NULL];
		[self setLines:[content componentsSeparatedByString:@"\n"]];
		[content release];
		
		NSMutableArray *lines = [self lines];
		
		int i,count = [lines count];
		NSString *_line;
		for (i=0;i<count;i++) {
			_line = [self skipWhitespace:[lines objectAtIndex:i]];
			[lines replaceObjectAtIndex:i withObject:_line];
			[self readConfLine:i];
		}
		
		NSDictionary *oldprefs = [[self conf] copy];
		[self read];
		NSEnumerator *keyEnum = [oldprefs keyEnumerator];
		NSString *key;
		while (key = [keyEnum nextObject])
			[self setOptionValue:[[oldprefs objectForKey:key] objectAtIndex:1] forKey:key];
			
		// we now can savely delete the old gift.conf file...
		[[NSFileManager defaultManager] removeFileAtPath:oldPrefFile handler:nil];
	}
}

@end
