//  HDPreferencesProtocolController.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDPreferencesProtocolController.h"
#import "HDPreferencesConfigurationEditor.h"


@implementation HDPreferencesProtocolController

- (Class)configurationEditorClass {
	return nil;	//[HDPreferencesConfigurationEditor class];
}

- (id)init {
	if (nil != (self = [super init])) {
		[self setConfigurationEditor:nil];
		[self setInterfaceEnabled:NO];
		
	    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(noteConfigurationFilesUpdated:) name:@"PUpdateFromConfFiles" object:nil];
	}
	return self;
}

- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	[self setConfigurationEditor:nil];
	
	[super dealloc];
}

- (void)noteConfigurationFilesUpdated:(NSNotification *)aNotification {
	[self readConfFiles];
}

- (void)readConfFiles {
	[self setConfigurationEditor:[[self configurationEditorClass] singleton]];
}

- (HDPreferencesConfigurationEditor *)configurationEditor {
	return AM_configurationEditor;
}

- (void)setConfigurationEditor:(HDPreferencesConfigurationEditor *)aConfigurationEditor {
	AM_configurationEditor = aConfigurationEditor;
}

- (BOOL)isInterfaceEnabled {
	return AM_interfaceEnabled;
}

- (void)setInterfaceEnabled:(BOOL)flag {
	AM_interfaceEnabled = flag;
}

@end
