//
//  HDPreferencesProtocolControllerAres.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------


#import "HDPreferencesProtocolControllerAres.h"
#import "HDPreferencesConfigurationEditorAres.h"

@implementation HDPreferencesProtocolControllerAres

- (Class)configurationEditorClass {
	return [HDPreferencesConfigurationEditorAres class];
}

- (void)awakeFromNib
{
    [self readConfFiles];
}

- (void)dealloc
{
	[port dealloc];
    [username dealloc];
    [super dealloc];
}


- (void)enable
{
    [port setEnabled:YES];
    [username setEnabled:YES];
}

- (void)disable
{
    [port setEnabled:NO];
    [username setEnabled:NO];
}

- (void)readConfFiles
{
	[super readConfFiles];
	
	id newConfigurationEditor = [self configurationEditor];
    if (newConfigurationEditor) {
		[self enable];
		
		[[self configurationEditor] read];
	
		[port setIntValue:[[newConfigurationEditor optionValueForKey:@"port"] intValue]];
		[username setStringValue:[newConfigurationEditor optionValueForKey:@"username"]];
	}
    else {
        [self disable];
    }
}

- (IBAction)newAlias:(id)sender
{
	// whitespace in user names causes problems
	// set to remove space, possible other whitespace characters can cause problems don't know yet
	// /t and /r are also considered whitespace but the input feilds don't accept those
	NSMutableString* nameString = [NSMutableString stringWithFormat:[sender stringValue]];
	NSRange entireString = NSMakeRange (0, [nameString length]);
	[nameString replaceOccurrencesOfString:@" " withString:@"_" options:NSLiteralSearch range:entireString];
    [[self configurationEditor] setOptionValue:nameString forKey:@"username"];
    [self readConfFiles];
}

- (IBAction)portChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"port"];
    [self readConfFiles];
}


@end
