//  HDPreferencesProtocolControllerFastTrack.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------


#import "HDPreferencesProtocolControllerFastTrack.h"
#import "HDPreferencesConfigurationEditorFastTrack.h"

#define userDefaults [NSUserDefaults standardUserDefaults]

@implementation HDPreferencesProtocolControllerFastTrack

- (Class)configurationEditorClass {
	return [HDPreferencesConfigurationEditorFastTrack class];
}

- (void)awakeFromNib
{
    [self readConfFiles];
     
    // NSUserDefaults * userDefaults;
    //userDefaults = [NSUserDefaults standarduserDefaults];
     
    //if ([userDefaults boolForKey:@"PAutoFMS"]) [enableAFMS setState:NSOnState];
    //else [enableAFMS setState:NSOffState];

}

- (void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [super dealloc];
}

- (void)readConfFiles
{
	[super readConfFiles];
	
	id newConfigurationEditor = [self configurationEditor];
    if (newConfigurationEditor) {
		[self setInterfaceEnabled:YES];
		
		[newConfigurationEditor read];
		
		[alias setStringValue:[newConfigurationEditor optionValueForKey:@"alias"]];
		[port setIntValue:[[newConfigurationEditor optionValueForKey:@"port"]intValue]];
		[forwardPort setIntValue:[[newConfigurationEditor optionValueForKey:@"forwarding"]intValue]];
		[enableBanList setIntValue:[[newConfigurationEditor optionValueForKey:@"banlist_filter"]intValue]];
		[enableSharing setIntValue:[[newConfigurationEditor optionValueForKey:@"allow_sharing"]intValue]];	
	}
    else {
        [self setInterfaceEnabled:NO];
    }
}

- (IBAction)newAlias:(id)sender
{
	// whitespace in user names causes problems
	// set to remove space, possible other whitespace characters can cause problems don't know yet
	// /t and /r are also considered whitespace but the input fields don't accept those
	//NSMutableString* nameString = [NSMutableString stringWithFormat:[sender stringValue]];
	NSMutableString *nameString = [[sender stringValue] mutableCopy];
	NSRange entireString = NSMakeRange (0, [nameString length]);
	[nameString replaceOccurrencesOfString:@" " withString:@"_" options:NSLiteralSearch range:entireString];
    [[self configurationEditor] setOptionValue:nameString forKey:@"alias"];
	[nameString release];
	
    [self readConfFiles];
}

- (IBAction)newPort:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"port"];
    [self readConfFiles];
}
- (IBAction)portForwardChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"forwarding"];

    [self readConfFiles]; 
}
- (IBAction)banListChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"banlist_filter"];

    [self readConfFiles];  
}

- (IBAction)sharingChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"allow_sharing"];

    [self readConfFiles];  
}
/*
- (IBAction)autoFindMoreSourcesChanged:(id)sender
{

    if ([enableAFMS state]==NSOnState) [userDefaults setBool:YES forKey:@"PAutoFMS"];
    else [userDefaults setBool:NO forKey:@"PAutoFMS"];

}
*/

@end
