//  HDPreferencesProtocolControllerGnutella.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------

#import "HDPreferencesProtocolControllerGnutella.h"

@implementation HDPreferencesProtocolControllerGnutella

- (Class)configurationEditorClass {
	return [HDPreferencesConfigurationEditorGnutella class];
}

- (void)awakeFromNib
{
    [self readConfFiles];
}



- (void)enable
{
        [port setEnabled:YES];
        [proxy setEnabled:YES];
}

- (void)disable
{
        [port setEnabled:NO];
        [proxy setEnabled:NO];
}

- (void)readConfFiles
{
	[super readConfFiles];

	id newConfigurationEditor = [self configurationEditor];
    if (newConfigurationEditor) {
		[self enable];
		
		[newConfigurationEditor read];
		
		[port setIntValue:[[newConfigurationEditor optionValueForKey:@"port"] intValue]];
		[proxy setStringValue:[newConfigurationEditor optionValueForKey:@"proxy"]];
	}
    else {
        [self disable];
    }
}

- (IBAction)newPort:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"port"];
    [self readConfFiles];
}

- (IBAction)newProxy:(id)sender
{
    [[self configurationEditor] setOptionValue:[sender stringValue] forKey:@"proxy"];
    [self readConfFiles];
}

@end
