//
//  HDPreferencesProtocolControllerOpenNap.m
// -------------------------------------------------------------------------
// Copyright (C) 2003 Poisoned Project <http://www.gottsilla.net/>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// Portions copyright (c) 2007 Andrew Merenbach <http://www.merenbach.com>
//	for Hedera <http://hedera.sourceforge.net/>.
// ---------------------------------------------------------------------------


#import "HDPreferencesProtocolControllerOpenNap.h"
#import "HDPreferencesConfigurationEditorOpenNap.h"

@implementation HDPreferencesProtocolControllerOpenNap

- (Class)configurationEditorClass {
	return [HDPreferencesConfigurationEditorOpenNap class];
}

- (void)awakeFromNib
{
    [self readConfFiles];
    /*if (randomAlias == 1) {
        [alias setState:NSOnState];
        [randomAlias setState:NSOnState];
    }
    else{
        [alias setState:NSOffState];
        [randomAlias setState:NSOnState];
    }*/

}

- (void)dealloc
{
    [alias dealloc];
    [randomAlias dealloc];
    [port dealloc];
    [maxconn dealloc];
    [useNapigator dealloc];
    [napigatorIP dealloc];
    [super dealloc];
}


- (void)enable
{
    [alias setEnabled:YES];
    [randomAlias setEnabled:YES];
    [port setEnabled:YES];
    [maxconn setEnabled:YES];
    [useNapigator setEnabled:YES];
    [napigatorIP setEnabled:YES];
}

- (void)disable
{
    [alias setEnabled:NO];
    [randomAlias setEnabled:NO];
    [port setEnabled:NO];
    [maxconn setEnabled:NO];
    [useNapigator setEnabled:NO];
    [napigatorIP setEnabled:NO];
}

- (void)readConfFiles
{
	[super readConfFiles];
	
	id newConfigurationEditor = [self configurationEditor];
    if (newConfigurationEditor) {
		[self enable];
		
		[newConfigurationEditor read];
		
		[alias setStringValue:[newConfigurationEditor optionValueForKey:@"alias"]];

		[randomAlias setIntValue:[[newConfigurationEditor optionValueForKey:@"random_alias"]intValue]];
		[port setIntValue:[[newConfigurationEditor optionValueForKey:@"dataport"]intValue]];
		[maxconn setIntValue:[[newConfigurationEditor optionValueForKey:@"max_connections"]intValue]];
		[useNapigator setIntValue:[[newConfigurationEditor optionValueForKey:@"use_napigator"]intValue]];
		[napigatorIP setStringValue:[newConfigurationEditor optionValueForKey:@"napigator_ip"]];
	}
    else {
        [self disable];
    }
}

- (IBAction)newAlias:(id)sender
{
    //[[self configurationEditor] setOptionValue:[NSString stringWithFormat:@"\"%@\"",[sender stringValue] optionValueForKey:@"alias"]];

    [[self configurationEditor] setOptionValue:[sender stringValue] forKey:@"alias"];
    
    [self readConfFiles];
}

- (IBAction)randomAliasChanged:(id)sender
{
    if ([randomAlias state]==NSOnState)
    {
        [alias setEnabled:NO];
    }
    else
    {
        [alias setEnabled:YES];
    }

     [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"random_alias"];
    
    [self readConfFiles];
}

- (IBAction)portChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"dataport"];
    [self readConfFiles];
}
- (IBAction)maxconnChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"max_connections"];
    [self readConfFiles];
}
- (IBAction)useNapigatorChanged:(id)sender
{
    if ([useNapigator state]==NSOnState)
    {
        [napigatorIP setEnabled:NO];
    }
    else
    {
        [napigatorIP setEnabled:YES];
    }

    [[self configurationEditor] setOptionValue:[NSNumber numberWithInt:[sender intValue]] forKey:@"use_napigator"];
    
    [self readConfFiles];
}
- (IBAction)napigatorIPChanged:(id)sender
{
    [[self configurationEditor] setOptionValue:[sender stringValue] forKey:@"napigator_ip"];
    [self readConfFiles];
}

@end
